Index: LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 1864)
@@ -1,4 +1,11 @@
 ! $Id$
 !
+
+MODULE phys_output_mod 
+  USE indice_sol_mod
+  USE phys_output_var_mod
+  USE aero_mod, only : naero_spc,name_aero
+  USE phys_output_write_mod, ONLY : phys_output_write
+
 ! Abderrahmane 12 2007
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -10,19 +17,4 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-MODULE phys_output_mod 
-  USE indice_sol_mod
-  USE phys_output_var_mod
-  USE phys_output_ctrlout_mod
-  USE aero_mod, only : naero_spc,name_aero
-
-  IMPLICIT NONE
-
-  PRIVATE histdef2d, histdef3d, conf_physoutputs
-
-  REAL, PRIVATE, SAVE                :: zdtime
-  !$OMP THREADPRIVATE(zdtime)
-
-
-
 CONTAINS
 
@@ -33,10 +25,12 @@
 
   SUBROUTINE phys_output_open(rlon,rlat,pim,tabij,ipt,jpt,plon,plat, &
-       jjmp1,nlevSTD,clevSTD,nbteta, &
+       jjmp1,nlevSTD,clevSTD,rlevSTD,nbteta, &
        ctetaSTD, dtime, ok_veget, &
        type_ocean, iflag_pbl,ok_mensuel,ok_journe, &
        ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, read_climoz, &
        phys_out_filestations, &
-       new_aod, aerosol_couple, flag_aerosol_strat)   
+       new_aod, aerosol_couple, flag_aerosol_strat, &
+       pdtphys, paprs, pphis, pplay, lmax_th, ptconv, ptconvth, ivap, &
+       d_t, qx, d_qx, zmasse, ok_sync)   
 
     USE iophy 
@@ -47,4 +41,10 @@
     USE mod_phys_lmdz_para
     USE aero_mod, only : naero_spc,name_aero
+    USE phys_output_ctrlout_mod
+
+#ifdef CPP_XIOS
+    ! ug Pour les sorties XIOS
+    USE wxios
+#endif
 
     IMPLICIT NONE
@@ -56,11 +56,24 @@
     include "iniprint.h"
 
-    real,dimension(klon),intent(in) :: rlon
-    real,dimension(klon),intent(in) :: rlat
-    INTEGER, intent(in)             :: pim
+    ! ug Nouveaux arguments nécessaires au histwrite_mod:
+    INTEGER, INTENT(IN)                         :: ivap
+    INTEGER, DIMENSION(klon), INTENT(IN)        :: lmax_th
+    LOGICAL, INTENT(IN)                         :: ok_sync
+    LOGICAL, DIMENSION(klon, klev), INTENT(IN)  :: ptconv, ptconvth
+    REAL, INTENT(IN)                            :: pdtphys
+    REAL, DIMENSION(klon), INTENT(IN)           :: pphis
+    REAL, DIMENSION(klon, klev), INTENT(IN)     :: pplay, d_t
+    REAL, DIMENSION(klon, klev+1), INTENT(IN)   :: paprs
+    REAL, DIMENSION(klon,klev,nqtot), INTENT(IN):: qx, d_qx
+    REAL, DIMENSION(klon, llm), INTENT(IN)      :: zmasse
+
+
+    REAL,DIMENSION(klon),INTENT(IN) :: rlon
+    REAL,DIMENSION(klon),INTENT(IN) :: rlat
+    INTEGER, INTENT(IN)             :: pim
     INTEGER, DIMENSION(pim)            :: tabij
-    INTEGER,dimension(pim), intent(in) :: ipt, jpt
-    REAL,dimension(pim), intent(in) :: plat, plon
-    REAL,dimension(pim,2) :: plat_bounds, plon_bounds
+    INTEGER,DIMENSION(pim), INTENT(IN) :: ipt, jpt
+    REAL,DIMENSION(pim), INTENT(IN) :: plat, plon
+    REAL,DIMENSION(pim,2) :: plat_bounds, plon_bounds
 
     INTEGER                               :: jjmp1
@@ -69,5 +82,5 @@
     LOGICAL                               :: ok_LES,ok_ade,ok_aie,flag_aerosol_strat
     LOGICAL                               :: new_aod, aerosol_couple
-    INTEGER, intent(in)::  read_climoz ! read ozone climatology
+    INTEGER, INTENT(IN)::  read_climoz ! read ozone climatology
     !     Allowed values are 0, 1 and 2
     !     0: do not read an ozone climatology
@@ -81,4 +94,5 @@
     REAL, DIMENSION(klev)                 :: Ahyb, Bhyb, Alt
     CHARACTER(LEN=4), DIMENSION(nlevSTD)  :: clevSTD
+    REAL, DIMENSION(nlevSTD)              :: rlevSTD
     INTEGER                               :: nsrf, k, iq, iiq, iff, i, j, ilev
     INTEGER                               :: naero
@@ -90,5 +104,4 @@
     CHARACTER(LEN=3)                      :: ctetaSTD(nbteta)
     REAL, DIMENSION(nfiles)               :: ecrit_files
-    CHARACTER(LEN=20), DIMENSION(nfiles)  :: phys_out_filenames
     INTEGER, DIMENSION(iim*jjmp1)         ::  ndex2d
     INTEGER, DIMENSION(iim*jjmp1*klev)    :: ndex3d
@@ -97,5 +110,6 @@
     INTEGER, DIMENSION(nfiles)            :: phys_out_levmin, phys_out_levmax
     INTEGER, DIMENSION(nfiles)            :: phys_out_filelevels
-    CHARACTER(LEN=20), DIMENSION(nfiles)  :: chtimestep   = (/ 'DefFreq', 'DefFreq','DefFreq', 'DefFreq', 'DefFreq', 'DefFreq' /)
+    CHARACTER(LEN=20), DIMENSION(nfiles)  :: chtimestep   = (/ '1mth', '1mth', '1mth', '1mth', '1mth', &
+                                                               '1mth', '1mth', '1mth', '1mth' /)
     LOGICAL, DIMENSION(nfiles)            :: phys_out_filekeys
     LOGICAL, DIMENSION(nfiles)            :: phys_out_filestations
@@ -104,9 +118,19 @@
     !                 entre [phys_out_lonmin,phys_out_lonmax] et [phys_out_latmin,phys_out_latmax]
 
-    LOGICAL, DIMENSION(nfiles), SAVE  :: phys_out_regfkey       = (/ .FALSE., .FALSE., .FALSE.,  .FALSE., .FALSE., .FALSE. /)
-    REAL, DIMENSION(nfiles), SAVE     :: phys_out_lonmin        = (/   -180.,   -180.,   -180.,    -180.,   -180.,   -180. /)
-    REAL, DIMENSION(nfiles), SAVE     :: phys_out_lonmax        = (/    180.,    180.,    180.,     180.,    180.,    180. /)
-    REAL, DIMENSION(nfiles), SAVE     :: phys_out_latmin        = (/    -90.,    -90.,    -90.,     -90.,    -90.,    -90. /)
-    REAL, DIMENSION(nfiles), SAVE     :: phys_out_latmax        = (/     90.,     90.,     90.,     90.,     90.,     90. /)
+    LOGICAL, DIMENSION(nfiles), SAVE  :: phys_out_regfkey       = (/ .FALSE., .FALSE., .FALSE.,  .FALSE., &
+                                                                    .FALSE., .FALSE., .FALSE., .FALSE.,  .FALSE. /)
+    REAL, DIMENSION(nfiles), SAVE     :: phys_out_lonmin        = (/   -180.,   -180.,   -180.,    -180., &
+                                                                     -180.,   -180., -180.,   -180.,    -180. /)
+    REAL, DIMENSION(nfiles), SAVE     :: phys_out_lonmax        = (/    180.,    180.,    180.,     180., &
+                                                                      180.,    180., 180.,    180.,     180. /)
+    REAL, DIMENSION(nfiles), SAVE     :: phys_out_latmin        = (/    -90.,    -90.,    -90.,     -90., &
+                                                                    -90., -90., -90.,    -90.,     -90. /)
+    REAL, DIMENSION(nfiles), SAVE     :: phys_out_latmax        = (/  90.,     90.,     90.,     90., &
+                                                                    90., 90., 90., 90., 90. /)                        
+#ifdef CPP_XIOS
+    ! ug Variables utilisées pour récupérer le calendrier pour xios
+    INTEGER :: x_an, x_mois, x_jour
+    REAL :: x_heure
+#endif
 
     WRITE(lunout,*) 'Debut phys_output_mod.F90'
@@ -115,6 +139,12 @@
     IF (.NOT. ALLOCATED(o_trac)) ALLOCATE(o_trac(nqtot))
     IF (.NOT. ALLOCATED(o_trac_cum)) ALLOCATE(o_trac_cum(nqtot))
-
-    levmax = (/ klev, klev, klev, klev, klev, klev /)
+    ALLOCATE(o_dtr_the(nqtot),o_dtr_con(nqtot),o_dtr_lessi_impa(nqtot))
+    ALLOCATE(o_dtr_lessi_nucl(nqtot),o_dtr_insc(nqtot),o_dtr_bcscav(nqtot))
+    ALLOCATE(o_dtr_evapls(nqtot),o_dtr_ls(nqtot),o_dtr_trsp(nqtot))
+    ALLOCATE(o_dtr_sscav(nqtot),o_dtr_sat(nqtot),o_dtr_uscav(nqtot))
+    ALLOCATE(o_dtr_dry(nqtot),o_dtr_vdf(nqtot))
+
+
+    levmax = (/ klev, klev, klev, klev, klev, klev, nlevSTD, nlevSTD, nlevSTD /)
 
     phys_out_filenames(1) = 'histmth'
@@ -124,4 +154,7 @@
     phys_out_filenames(5) = 'histLES'
     phys_out_filenames(6) = 'histstn'
+    phys_out_filenames(7) = 'histmthNMC'
+    phys_out_filenames(8) = 'histdayNMC'
+    phys_out_filenames(9) = 'histhfNMC.nc'
 
     type_ecri(1) = 'ave(X)'
@@ -131,4 +164,7 @@
     type_ecri(5) = 'ave(X)'
     type_ecri(6) = 'inst(X)'
+    type_ecri(7) = 'inst(X)'
+    type_ecri(8) = 'inst(X)'
+    type_ecri(9) = 'inst(X)'
 
     clef_files(1) = ok_mensuel
@@ -138,4 +174,7 @@
     clef_files(5) = ok_LES
     clef_files(6) = ok_instan
+    clef_files(7) = ok_histNMC(1)
+    clef_files(8) = ok_histNMC(2)
+    clef_files(9) = ok_histNMC(3)
 
     !sortir des fichiers "stations" si clef_stations(:)=.TRUE.
@@ -146,4 +185,7 @@
     clef_stations(5) = .FALSE.
     clef_stations(6) = .FALSE.
+    clef_stations(7) = .FALSE.
+    clef_stations(8) = .FALSE.
+    clef_stations(9) = .FALSE.
 
     lev_files(1) = lev_histmth
@@ -153,4 +195,7 @@
     lev_files(5) = lev_histLES
     lev_files(6) = lev_histins
+    lev_files(7) = levout_histNMC(1)
+    lev_files(8) = levout_histNMC(2)
+    lev_files(9) = levout_histNMC(3)
 
     ecrit_files(1) = ecrit_mth
@@ -160,4 +205,7 @@
     ecrit_files(5) = ecrit_LES
     ecrit_files(6) = ecrit_ins
+    ecrit_files(7) = freq_outNMC(1)/86400.
+    ecrit_files(8) = freq_outNMC(2)/86400.
+    ecrit_files(9) = freq_outNMC(3)/86400.
 
     !! Lectures des parametres de sorties dans physiq.def
@@ -195,4 +243,12 @@
     WRITE(lunout,*)'phys_out_filelevels=',lev_files
 
+#ifdef CPP_XIOS
+    ! ug Réglage du calendrier xios
+    !Temps julian => an, mois, jour, heure
+    CALL ymds2ju(annee_ref, 1, day_ref, 0.0, zjulian)
+    CALL ju2ymds(zjulian, x_an, x_mois, x_jour, x_heure)
+    CALL wxios_set_cal(dtime, calend, x_an, x_mois, x_jour, x_heure)
+#endif
+
 !!!!!!!!!!!!!!!!!!!!!!! Boucle sur les fichiers !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     ! Appel de histbeg et histvert pour creer le fichier et les niveaux verticaux !!
@@ -200,5 +256,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-    zdtime = dtime         ! Frequence ou l on moyenne
+    zdtime_moy = dtime         ! Frequence ou l on moyenne
 
     ! Calcul des Ahyb, Bhyb et Alt
@@ -226,4 +282,21 @@
        zoutm(iff) = ecrit_files(iff) ! Frequence ou l on ecrit en seconde
 
+
+#ifdef CPP_XIOS
+    ! ug déclaration des axes verticaux de chaque fichier:
+    CALL wxios_add_vaxis("presnivs", phys_out_filenames(iff), &
+            levmax(iff) - levmin(iff) + 1, presnivs(levmin(iff):levmax(iff)))
+    CALL wxios_add_vaxis("Ahyb", phys_out_filenames(iff), &
+            levmax(iff) - levmin(iff) + 1, Ahyb)
+    CALL wxios_add_vaxis("Bhyb", phys_out_filenames(iff), &
+            levmax(iff) - levmin(iff) + 1, Bhyb)
+    CALL wxios_add_vaxis("Ahyb", phys_out_filenames(iff), &
+            levmax(iff) - levmin(iff) + 1, Alt)
+
+    IF (clef_files(iff)) THEN
+         CALL wxios_add_file(phys_out_filenames(iff),chtimestep(iff),lev_files(iff))
+    END IF
+#endif 
+
        IF (clef_files(iff)) THEN
 
@@ -243,5 +316,4 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
           IF (phys_out_regfkey(iff)) then
-
              imin_ins=1
              imax_ins=iim
@@ -283,24 +355,14 @@
                   itau_phy,zjulian,dtime,nhorim(iff),nid_files(iff))
           else
-             CALL histbeg_phy(phys_out_filenames(iff),itau_phy,zjulian,dtime,nhorim(iff),nid_files(iff))
+             CALL histbeg_phy_all(phys_out_filenames(iff),itau_phy,zjulian,&
+                 dtime,nhorim(iff),nid_files(iff))
           endif
 
-          CALL histvert(nid_files(iff), "presnivs", "Vertical levels", "Pa", &
+#ifndef CPP_NO_IOIPSL 
+          if (iff.le.6) then
+             CALL histvert(nid_files(iff), "presnivs", "Vertical levels", "Pa", &  
                levmax(iff) - levmin(iff) + 1, &
                presnivs(levmin(iff):levmax(iff)), nvertm(iff),"down")
-
-!!!!!!!!!!!!! Traitement des champs 3D pour histhf !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!!!!!!!!!!!!!!! A Revoir plus tard !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-          !          IF (iff.eq.3.and.lev_files(iff).ge.4) THEN
-          !          CALL histbeg_phy("histhf3d",itau_phy, &
-          !     &                     zjulian, dtime, &
-          !     &                     nhorim, nid_hf3d)
-
-          !         CALL histvert(nid_hf3d, "presnivs", &
-          !     &                 "Vertical levels", "mb", &
-          !     &                 klev, presnivs/100., nvertm)
-          !          ENDIF
-          !
-!!!! Composentes de la coordonnee sigma-hybride 
+!!!! Composantes de la coordonnee sigma-hybride 
           CALL histvert(nid_files(iff), "Ahyb","Ahyb comp of Hyb Cord ", "Pa", &
                levmax(iff) - levmin(iff) + 1,Ahyb,nvertap(iff))
